set define off
set verify off
set feedback off
WHENEVER SQLERROR EXIT SQL.SQLCODE ROLLBACK
begin wwv_flow.g_import_in_progress := true; end;
/
 
--       AAAA       PPPPP   EEEEEE  XX      XX
--      AA  AA      PP  PP  EE       XX    XX
--     AA    AA     PP  PP  EE        XX  XX
--    AAAAAAAAAA    PPPPP   EEEE       XXXX
--   AA        AA   PP      EE        XX  XX
--  AA          AA  PP      EE       XX    XX
--  AA          AA  PP      EEEEEE  XX      XX
prompt  Set Credentials...
 
begin
 
  -- Assumes you are running the script connected to SQL*Plus as the Oracle user APEX_040200 or as the owner (parsing schema) of the application.
  wwv_flow_api.set_security_group_id(p_security_group_id=>nvl(wwv_flow_application_install.get_workspace_id,7364030591001062));
 
end;
/

begin wwv_flow.g_import_in_progress := true; end;
/
begin 

select value into wwv_flow_api.g_nls_numeric_chars from nls_session_parameters where parameter='NLS_NUMERIC_CHARACTERS';

end;

/
begin execute immediate 'alter session set nls_numeric_characters=''.,''';

end;

/
begin wwv_flow.g_browser_language := 'en'; end;
/
prompt  Check Compatibility...
 
begin
 
-- This date identifies the minimum version required to import this file.
wwv_flow_api.set_version(p_version_yyyy_mm_dd=>'2012.01.01');
 
end;
/

prompt  Set Application ID...
 
begin
 
   -- SET APPLICATION ID
   wwv_flow.g_flow_id := nvl(wwv_flow_application_install.get_application_id,99999);
   wwv_flow_api.g_id_offset := nvl(wwv_flow_application_install.get_offset,0);
null;
 
end;
/

prompt  ...ui types
--
 
begin
 
null;
 
end;
/

prompt  ...plugins
--
--application/shared_components/plugins/item_type/org_armbruster_it_apex_weather
 
begin
 
wwv_flow_api.create_plugin (
  p_id => 7532908933378195 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_type => 'ITEM TYPE'
 ,p_name => 'ORG.ARMBRUSTER-IT.APEX.WEATHER'
 ,p_display_name => 'Weather (IT-STAR)'
 ,p_supported_ui_types => 'DESKTOP'
 ,p_image_prefix => '#PLUGIN_PREFIX#'
 ,p_plsql_code => 
'/* Extract LAT and LNG out of a GPS String */'||unistr('\000a')||
'procedure extract_gps_lat_lng(pi_gps in varchar2,'||unistr('\000a')||
'                                po_lat out varchar2,'||unistr('\000a')||
'                                po_lng out varchar2) is'||unistr('\000a')||
'    l_gps    varchar2(1000);'||unistr('\000a')||
'    l_pos    number;'||unistr('\000a')||
'    l_length number;'||unistr('\000a')||
'  '||unistr('\000a')||
'begin'||unistr('\000a')||
'    l_gps := replace(pi_gps, '' '', '''');'||unistr('\000a')||
'  '||unistr('\000a')||
'    l_pos    := instr(l_gps, '','');'||unistr('\000a')||
'    l_length := length(l_gps);'||unistr('\000a')||
'  '||unistr('\000a')||
'    '||
'po_lat := substr(l_gps, 1, l_pos - 1);'||unistr('\000a')||
'    po_lng := substr(l_gps, l_pos + 1, l_length - l_pos);'||unistr('\000a')||
'  '||unistr('\000a')||
'end;'||unistr('\000a')||
''||unistr('\000a')||
'/*-------------------------------------'||unistr('\000a')||
' * Weather Callback Function'||unistr('\000a')||
' * Version: 1.0 (13.11.2014)'||unistr('\000a')||
' * Author:  S. Armbruster'||unistr('\000a')||
' * Requires: '||unistr('\000a')||
' *-------------------------------------'||unistr('\000a')||
'*/'||unistr('\000a')||
'function render_weather(p_item                IN APEX_PLUGIN.t_page_item,'||unistr('\000a')||
'                          p_plugin     '||
'         in APEX_PLUGIN.t_plugin,'||unistr('\000a')||
'                          p_value               IN VARCHAR2,'||unistr('\000a')||
'                          p_is_readonly         IN BOOLEAN,'||unistr('\000a')||
'                          p_is_printer_friendly IN BOOLEAN)'||unistr('\000a')||
'    RETURN APEX_PLUGIN.t_page_item_render_result IS'||unistr('\000a')||
'    l_result        APEX_PLUGIN.T_PAGE_ITEM_RENDER_RESULT;'||unistr('\000a')||
'    l_escaped_value varchar2(32767) := sys.htf.escape_sc(p_value);'||unistr('\000a')||
'    --'||unistr('\000a')||
''||
'    l_name         varchar2(30);'||unistr('\000a')||
'    l_mode         apex_application_page_items.attribute_01%type := p_item.attribute_01;'||unistr('\000a')||
'    l_heigth       apex_application_page_items.attribute_02%type := p_item.attribute_02;'||unistr('\000a')||
'    l_width        apex_application_page_items.attribute_03%type := p_item.attribute_03;'||unistr('\000a')||
'    l_text_visible apex_application_page_items.attribute_04%type := p_item.attribute_04;'||unistr('\000a')||
'    l_text_'||
'pos     apex_application_page_items.attribute_05%type := p_item.attribute_05;'||unistr('\000a')||
'    l_lat          varchar2(20);'||unistr('\000a')||
'    l_lng          varchar2(20);'||unistr('\000a')||
'    l_city         varchar2(200);'||unistr('\000a')||
'    l_para         varchar2(1000);'||unistr('\000a')||
'    l_value        varchar2(2000);'||unistr('\000a')||
'    l_weather_html varchar2(2000);'||unistr('\000a')||
'    l_item_html    varchar2(2000);'||unistr('\000a')||
'    l_html_string  varchar2(2000);'||unistr('\000a')||
'  begin'||unistr('\000a')||
'  '||unistr('\000a')||
'    -- Print the Item '||unistr('\000a')||
'    l_name :='||
' apex_plugin.get_input_name_for_page_item(false);'||unistr('\000a')||
'  '||unistr('\000a')||
'    l_item_html := ''<input type="text" style="text-align: left'' ||'||unistr('\000a')||
'                   ''" name="'' || l_name || ''" id="'' || p_item.name || ''" '' ||'||unistr('\000a')||
'                   ''value="'' || htf.escape_sc(p_value) || ''" placeholder="'' ||'||unistr('\000a')||
'                   p_item.placeholder || ''" '' || ''" size="'' ||'||unistr('\000a')||
'                   p_item.element_width || ''" '' || ''maxlengt'||
'h="'' ||'||unistr('\000a')||
'                   p_item.element_max_length || ''" '' ||'||unistr('\000a')||
'                   p_item.element_attributes || ''"/>'';'||unistr('\000a')||
'  '||unistr('\000a')||
'    if nvl(l_mode, ''city'') = ''city'' then'||unistr('\000a')||
'      l_para := ''q='' || apex_util.url_encode(p_value);'||unistr('\000a')||
'    else'||unistr('\000a')||
'      extract_gps_lat_lng(apex_util.url_encode(p_value), l_lat, l_lng);'||unistr('\000a')||
'    '||unistr('\000a')||
'      l_para := ''lat='' || l_lat || ''&lon='' || l_lng;'||unistr('\000a')||
'    end if;'||unistr('\000a')||
'    l_para := l_para || ''&mode='||
'html'';'||unistr('\000a')||
'  '||unistr('\000a')||
'    l_heigth := nvl(l_heigth, 200);'||unistr('\000a')||
'    l_width  := nvl(l_width, 200);'||unistr('\000a')||
'  '||unistr('\000a')||
'    l_text_visible := nvl(l_text_visible, ''Y'');'||unistr('\000a')||
'    l_text_pos     := nvl(l_text_pos, ''top'');'||unistr('\000a')||
'  '||unistr('\000a')||
'    l_weather_html := ''<iframe width="'' || l_width || ''" height="'' ||'||unistr('\000a')||
'                      l_heigth ||'||unistr('\000a')||
'                      ''" scrolling="no" frameborder="0" src="http://api.openweathermap.org/data/2.5/weather?'' ||'||unistr('\000a')||
'  '||
'                    l_para || ''"></iframe>'';'||unistr('\000a')||
'  '||unistr('\000a')||
'    if l_text_visible = ''Y'' then'||unistr('\000a')||
'      if l_text_pos = ''top'' then'||unistr('\000a')||
'        l_html_string := ''<table><tr><td>'' || l_item_html || ''</td></tr>'' ||'||unistr('\000a')||
'                         ''<tr><td>'' || l_weather_html || ''</td></tr>'' ||'||unistr('\000a')||
'                         ''</table>'';'||unistr('\000a')||
'      elsif l_text_pos = ''bottom'' then'||unistr('\000a')||
'        l_html_string := ''<table><tr><td>'' || l_weather_html'||
' ||'||unistr('\000a')||
'                         ''</td></tr>'' || ''<tr><td>'' || l_item_html ||'||unistr('\000a')||
'                         ''</td></tr>'' || ''</table>'';'||unistr('\000a')||
'      elsif l_text_pos = ''left'' then'||unistr('\000a')||
'        l_html_string := ''<table><tr><td valign="top">'' || l_item_html ||'||unistr('\000a')||
'                         ''</td><td>'' || l_weather_html ||'||unistr('\000a')||
'                         ''</td></tr></table>'';'||unistr('\000a')||
'      elsif l_text_pos = ''right'' then'||unistr('\000a')||
'        l_html_stri'||
'ng := ''<table><tr><td valign="top">'' || l_weather_html ||'||unistr('\000a')||
'                         ''</td><td>'' || l_item_html ||'||unistr('\000a')||
'                         ''</td></tr></table>'';'||unistr('\000a')||
'      else'||unistr('\000a')||
'        null;'||unistr('\000a')||
'      end if;'||unistr('\000a')||
'    else'||unistr('\000a')||
'      l_html_string := ''<table><tr><td>'' || l_weather_html || ''</td></tr>'' ||'||unistr('\000a')||
'                       ''</table>'';'||unistr('\000a')||
'    end if;'||unistr('\000a')||
'  '||unistr('\000a')||
'    htp.prn(l_html_string);'||unistr('\000a')||
'  '||unistr('\000a')||
'  '||unistr('\000a')||
'    l_result.is_navigable := T'||
'RUE;'||unistr('\000a')||
'  '||unistr('\000a')||
'    return(l_result);'||unistr('\000a')||
'end;'||unistr('\000a')||
''
 ,p_render_function => 'render_weather'
 ,p_standard_attributes => 'VISIBLE:SESSION_STATE:READONLY:SOURCE:ELEMENT:WIDTH:HEIGHT:ELEMENT_OPTION:PLACEHOLDER:ENCRYPT'
 ,p_substitute_attributes => true
 ,p_subscribe_plugin_settings => true
 ,p_version_identifier => '1.0'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 7533322611523772 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 7532908933378195 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 1
 ,p_display_sequence => 10
 ,p_prompt => 'Mode'
 ,p_attribute_type => 'SELECT LIST'
 ,p_is_required => true
 ,p_default_value => 'city'
 ,p_is_translatable => false
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 7533621102524470 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 7533322611523772 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 10
 ,p_display_value => 'City'
 ,p_return_value => 'city'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 7534020023524978 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 7533322611523772 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 20
 ,p_display_value => 'GPS'
 ,p_return_value => 'gps'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 7535627522582363 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 7532908933378195 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 2
 ,p_display_sequence => 20
 ,p_prompt => 'Height'
 ,p_attribute_type => 'NUMBER'
 ,p_is_required => true
 ,p_default_value => '200'
 ,p_display_length => 10
 ,p_max_length => 10
 ,p_is_translatable => false
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 7536022346584708 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 7532908933378195 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 3
 ,p_display_sequence => 30
 ,p_prompt => 'Width'
 ,p_attribute_type => 'NUMBER'
 ,p_is_required => true
 ,p_default_value => '200'
 ,p_display_length => 10
 ,p_max_length => 10
 ,p_is_translatable => false
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 7536815309755152 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 7532908933378195 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 4
 ,p_display_sequence => 40
 ,p_prompt => 'Textbox visible'
 ,p_attribute_type => 'CHECKBOX'
 ,p_is_required => false
 ,p_default_value => 'Y'
 ,p_is_translatable => false
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 7537212721756342 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 7532908933378195 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 5
 ,p_display_sequence => 50
 ,p_prompt => 'Textpos Position'
 ,p_attribute_type => 'SELECT LIST'
 ,p_is_required => true
 ,p_default_value => 'top'
 ,p_is_translatable => false
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 7537611212757029 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 7537212721756342 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 10
 ,p_display_value => 'Top'
 ,p_return_value => 'top'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 7538009702757760 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 7537212721756342 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 20
 ,p_display_value => 'Bottom'
 ,p_return_value => 'bottom'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 7538408192758415 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 7537212721756342 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 30
 ,p_display_value => 'Right'
 ,p_return_value => 'right'
  );
wwv_flow_api.create_plugin_attr_value (
  p_id => 7538806467759246 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_attribute_id => 7537212721756342 + wwv_flow_api.g_id_offset
 ,p_display_sequence => 40
 ,p_display_value => 'Left'
 ,p_return_value => 'left'
  );
null;
 
end;
/

commit;
begin
execute immediate 'begin sys.dbms_session.set_nls( param => ''NLS_NUMERIC_CHARACTERS'', value => '''''''' || replace(wwv_flow_api.g_nls_numeric_chars,'''''''','''''''''''') || ''''''''); end;';
end;
/
set verify on
set feedback on
set define on
prompt  ...done
